using System;
using System.Threading;

class Example4

{
    static int x=0;
    static readonly object locker = new object();
     public static void Ex4_monitor()
    {
        for (int i = 0; i < 5; i++)
        {
            Thread myThread = new Thread(Count)
            {
                Name = $"Поток {i.ToString()}"
            };
            myThread.Start();
        }
 
        Console.WriteLine("\nComplete...\n\n");
    }
    public static void Count()
    {
        bool acquiredLock = false;
        try
        {
            Monitor.Enter(locker, ref acquiredLock);
            x = 1;
            for (int i = 1; i < 9; i++)
            {
                Console.WriteLine($"{Thread.CurrentThread.Name}: {x}");
                x++;
                Thread.Sleep(100);
            }
        }
        finally
        {
            if(acquiredLock) Monitor.Exit(locker);
        }
    }
}
